' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports Microsoft.Data.Caching
Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Private Function GetCurrentCache() As DataCache
        Dim dCache As DataCache

        If Not Session("dCache") Is Nothing Then
            dCache = Session("dCache")
        Else
            Dim factory As New DataCacheFactory
            dCache = factory.GetCache("default")
            Session("dCache") = dCache
        End If

        Return dCache
    End Function

    Protected Sub addButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles addButton.Click
        Dim dCache = GetCurrentCache()

        Dim key = keyTextbox.Text
        Dim val = valueTxtBox.Text

        If key Is "" OrElse val Is "" Then
            Return
        End If

        Try
            dCache.Add(key, val)
            statusLabel.Text = String.Format("Successfully added key {0} to cache.",
                                       key)
        Catch ex As Exception
            statusLabel.Text = String.Format("Error adding key {0} to cache: {1}",
                                      key, ex.Message)
        End Try
    End Sub

    Protected Sub putButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles putButton.Click
        Dim dCache = GetCurrentCache()

        Dim key = keyTextbox.Text
        Dim val = valueTxtBox.Text

        If key Is "" OrElse val Is "" Then
            Return
        End If

        Try
            dCache.Put(key, val)
            statusLabel.Text = String.Format("Successfully put key {0} to cache",
                                              key)
        Catch ex As Exception
            statusLabel.Text = String.Format("Error putting key {0} to cache: {1}",
                                              key, ex.Message)
        End Try
    End Sub

    Protected Sub getButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles getButton.Click
        Dim dCache = GetCurrentCache()
        Dim key = keyTextbox.Text

        If key Is "" Then
            Return
        End If

        Try
            Dim val = dCache.Get(key).ToString()
            valueTxtBox.Text = val
            statusLabel.Text = String.Format("Successfully did Get of key {0} from cache", key)
        Catch ex As Exception
            statusLabel.Text = String.Format("Error getting key {0} from cache: {1}", key, ex.Message)
        End Try
    End Sub
End Class