' ----------------------------------------------------------------------------------
' Microsoft Developer & Platform Evangelism
' 
' Copyright (c) Microsoft Corporation. All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, 
' EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
' OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
' ----------------------------------------------------------------------------------
' The example companies, organizations, products, domain names,
' e-mail addresses, logos, people, places, and events depicted
' herein are fictitious.  No association with any real company,
' organization, product, domain name, email address, logo, person,
' places, or events is intended or should be inferred.
' ----------------------------------------------------------------------------------

Imports Microsoft.Data.Caching
Public Class WebForm1
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Private Function GetCurrentCache() As DataCache
        Dim dCache As DataCache
        If Session("dCache") IsNot Nothing Then
            dCache = CType(Session("dCache"), DataCache)
        Else
            Dim factory = New DataCacheFactory()
            dCache = factory.GetCache("default")
            Session("dCache") = dCache
        End If

        Return dCache
    End Function

    Protected Sub AddButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles AddButton.Click
        Dim dCache = GetCurrentCache()
        Dim employeeID = Convert.ToInt32(EmployeeIDTextbox.Text)
        Dim firstName = FirstNameTextbox.Text
        Dim lastName = LastNameTextbox.Text
        Dim address = AddressTextbox.Text
        Dim hireDate = Convert.ToDateTime(HireDateTextbox.Text)

        Dim emp = New Employee With {
            .EmployeeID = employeeID,
            .FirstName = firstName,
            .LastName = lastName,
            .Address = address,
            .HireDate = hireDate
        }

        Try
            dCache.Add(employeeID.ToString(), emp)
            StatusLabel.Text = String.Format("Successfully added employee {0} to cache", employeeID)
        Catch ex As Exception
            StatusLabel.Text = String.Format("Error adding employee {0} to cache: {1}", employeeID, ex.Message)
        End Try
    End Sub

    Protected Sub PutButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles PutButton.Click
        Dim dCache = GetCurrentCache()
        Dim employeeID = Convert.ToInt32(EmployeeIDTextbox.Text)
        Dim firstName = FirstNameTextbox.Text
        Dim lastName = LastNameTextbox.Text
        Dim address = AddressTextbox.Text
        Dim hireDate = Convert.ToDateTime(HireDateTextbox.Text)

        Dim emp = New Employee With {
            .EmployeeID = employeeID,
            .FirstName = firstName,
            .LastName = lastName,
            .Address = address,
            .HireDate = hireDate
        }

        Try
            dCache.Put(employeeID.ToString(), emp)
            StatusLabel.Text = String.Format("Successfully added employee {0} to cache", employeeID)
        Catch ex As Exception
            StatusLabel.Text = String.Format("Error putting employee {0} to cache: {1}", employeeID, ex.Message)
        End Try
    End Sub

    Protected Sub GetButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles GetButton.Click
        Dim dCache = GetCurrentCache()

        Try
            Dim emp = CType(dCache.Get(EmployeeIDTextbox.Text), Employee)
            FirstNameTextbox.Text = emp.FirstName
            LastNameTextbox.Text = emp.LastName
            AddressTextbox.Text = emp.Address
            HireDateTextbox.Text = emp.HireDate.ToString()

            StatusLabel.Text = String.Format("Successfully did Get of employee {0} from cache", emp.EmployeeID)
        Catch ex As Exception
            StatusLabel.Text = String.Format("Error getting employee {0} and {1}", EmployeeIDTextbox.Text, ex.Message)
        End Try
    End Sub
End Class